/// tksdisplaylist.cpp
///
/// (c) 2001-2004 Bastian Spiegel <bs@tkscript.de> 
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///

#include "static_tkopengl.h"

#include <stdlib.h>
#include <math.h>

#define YAC_PRINTF defined
#include <yac.h>

extern YAC_Host *yac_host;
extern sUI clid_Vector;

#include <tks-opengl.h>
#include <GL/glu.h>
#ifndef DX_STATIC_TKOPENGL
#include <tks-list.h>
#endif

#include "bitmap.h"
#include "image.h"
#include "tkstexture.h"
#include "chaosmath.h"
#include "tksmath.h"
#include "tksopengl.h"

extern sUI clid_Vector;
extern sUI clid_Matrix;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~                                                                ~
//~ DisplayList                                                    ~
//~                                                                ~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DisplayList::_DisplayList(void) {
	gl_dlist=-1;
}

_DisplayList::~_DisplayList() {
	_free();
}

void _DisplayList::_setName(YAC_String *_n) {
    name.yacCopy((YAC_String*)_n);
}

YAC_String *_DisplayList::_getName(void) {
    return &name;
}

void _DisplayList::yacOperator(sSI _op, YAC_Object *_o, YAC_Value *_r) {
}

void _DisplayList::_alloc(void) {
	_DisplayList::_free();
	gl_dlist=::glGenLists(1);
}

void _DisplayList::_free(void) {
	if(gl_dlist!=-1)
	{
		::glDeleteLists(gl_dlist, 1);
		gl_dlist=-1;
	}
}

void _DisplayList::_begin(void) {
    if(gl_dlist!=-1)
		::glNewList(gl_dlist, GL_COMPILE_AND_EXECUTE);
}

void _DisplayList::_end(void) {
    if(gl_dlist!=-1)
    {
		::glEndList();
    }
}

void _DisplayList::_draw(void) {
    if(gl_dlist!=-1)
    {
		::glCallList(gl_dlist);
	}
}

sSI _DisplayList::_getId(void) {
	return gl_dlist;
}
