/// tksopengl.cpp
///
/// (c) 2001-2005 Bastian Spiegel <bs@tkscript.de> 
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///

#include "static_tkopengl.h"

#include <stdlib.h>
#include <math.h>

#define YAC_PRINTF defined
#include <yac.h>


extern YAC_Host *yac_host;
extern sUI clid_Vector;

#include <tks-opengl.h>
#include <GL/glu.h>
#ifndef DX_STATIC_TKOPENGL
#include <tks-list.h>
#endif

#include "bitmap.h"
#include "image.h"
#include "tkstexture.h"
#include "chaosmath.h"
#include "tksmath.h"
#include "tksopengl.h"

extern sUI clid_Vector;
extern sUI clid_Matrix;

void YAC_CALL _glAlphaFunc(sSI _a, sF32 _b)         { ::glAlphaFunc(_a, _b); }
void YAC_CALL _glArrayElement(sSI _a)               { ::glArrayElement(_a); }
void YAC_CALL _glBegin(sSI _a)                      { ::glBegin(_a); }
void YAC_CALL _glBindTexture(sSI _a, sSI _b)        { ::glBindTexture(_a, _b); }
void YAC_CALL _glBlendFunc(sSI _a, sSI _b)          { ::glBlendFunc(_a, _b); }
void YAC_CALL _glCallList(sSI _a)                   { ::glCallList(_a); }
void YAC_CALL _glCullFace(sSI _a)                   { ::glCullFace(_a); }
void YAC_CALL _glClearColor(sF32 _a, sF32 _b, 
				   sF32 _c, sF32 _d)       { ::glClearColor(_a,_b,_c,_d); }
void YAC_CALL _glClear(sSI _a)                      { ::glClear(_a); }
void YAC_CALL _glClearDepth(sF32 _a)                { ::glClearDepth(_a); }
void YAC_CALL _glClearStencil(sSI _a)               { ::glClearStencil(_a); }
void YAC_CALL _glColor3f(sF32 _a, sF32 _b, sF32 _c) { ::glColor3f(_a, _b, _c); }
void YAC_CALL _glColor3ub(sSI _a, sSI _b, sSI _c)   { ::glColor3ub(_a, _b, _c); }
void YAC_CALL _glColor4f(sF32 _a, sF32 _b, sF32 _c, sF32 _d) { ::glColor4f(_a, _b, _c, _d); }
void YAC_CALL _glColor4ub(sSI _a, sSI _b, 
				 sSI _c, sSI _d)           { ::glColor4ub(_a, _b, _c, _d); }
void YAC_CALL _glColorMask(sSI _a, sSI _b, sSI _c, sSI _d) { ::glColorMask(_a, _b, _c, _d); }
void YAC_CALL _glCopyPixels(sSI _a, sSI _b, 
				   sSI _c, sSI _d, 
				   sSI _e)                 { ::glCopyPixels(_a, _b, _c, _d, _e); }
void YAC_CALL _glCopyTexSubImage2D(sSI _a, sSI _b, 
						  sSI _c, sSI _d, 
						  sSI _e, sSI _f, 
						  sSI _g, sSI _h)  { ::glCopyTexSubImage2D(_a, _b, _c, _d, _e, _f, _g, _h); }
void YAC_CALL _glCopyTexImage2D(sSI _a, sSI _b, 
						   sSI _c, sSI _d, 
						   sSI _e, sSI _f, 
						   sSI _g, sSI _h) { ::glCopyTexImage2D(_a, _b, _c, _d, _e, _f, _g, _h); }
void YAC_CALL _glDepthFunc(sSI _a)                  { ::glDepthFunc(_a); }
void YAC_CALL _glDepthMask(sSI _a)                  { ::glDepthMask(_a); }
void YAC_CALL _glDisable(sSI _a)                    { ::glDisable(_a); }
void YAC_CALL _glDisableClientState(sSI _a)         { ::glDisableClientState(_a); }
void YAC_CALL _glDrawArrays(sSI _a, sSI _b, sSI _c) { ::glDrawArrays(_a, _b, _c); }
void YAC_CALL _glDrawElements(sSI _gltype, YAC_Object *_intarray) {
	if(_intarray)
	{
		if(_intarray->yacArrayGetElementType()==1)
		if(_intarray->yacArrayGetElementByteSize()==4)
		{
			sUI num=_intarray->yacArrayGetNumElements();
			::glDrawElements(_gltype, num, GL_UNSIGNED_INT, _intarray->yacArrayGetPointer());
		}
	}
}

void YAC_CALL _glDrawBuffer(sSI _a)                 { ::glDrawBuffer(_a); }
void YAC_CALL _glEdgeFlag(sSI _a)                   { ::glEdgeFlag(_a); }
void YAC_CALL _glEnable(sSI _a)                     { ::glEnable(_a); }
void YAC_CALL _glEnableClientState(sSI _a)          { ::glEnableClientState(_a); }
void YAC_CALL _glEnd(void)                          { ::glEnd(); }
void YAC_CALL _glFinish(void)                       { ::glFinish(); }
void YAC_CALL _glFlush(void)                        { ::glFlush(); }
void YAC_CALL _glFrontFace(sSI _a)                  { ::glFrontFace(_a); }
void YAC_CALL _glFrustum(sF32 _a, sF32 _b, sF32 _c, 
				sF32 _d, sF32 _e, sF32 _f) { ::glFrustum(_a, _b, _c, _d, _e, _f); }
void YAC_CALL _glHint(sSI _a, sSI _b)               { ::glHint(_a, _b); }
void YAC_CALL _glLoadIdentity(void)                 { ::glLoadIdentity(); }
void YAC_CALL _glLineWidth(sF32 _a)                 { ::glLineWidth(_a); }
void YAC_CALL _glLineStipple(sSI _a, sSI _b)        { ::glLineStipple(_a, _b); }
void YAC_CALL _glLogicOp(sSI _a)                    { ::glLogicOp(_a); }
void YAC_CALL _glMatrixMode(sSI _a)                 { ::glMatrixMode(_a); }
void YAC_CALL _glNormal3f(sF32 _a, sF32 _b, sF32 _c) { ::glNormal3f(_a, _b, _c); }
void YAC_CALL _glOrtho(sF32 _a, sF32 _b, sF32 _c, 
			  sF32 _d, sF32 _e, sF32 _f)   { ::glOrtho(_a, _b, _c, _d, _e, _f); }
void YAC_CALL _glPointSize(sF32 _a)                 { ::glPointSize(_a); }
void YAC_CALL _glPixelZoom(sF32 _a, sF32 _b)        { ::glPixelZoom(_a, _b); }
void YAC_CALL _glPolygonMode(sSI _a, sSI _b)        { ::glPolygonMode(_a, _b); }
void YAC_CALL _glPopAttrib(void)                    { ::glPopAttrib(); }
void YAC_CALL _glPushAttrib(sSI _a)                 { ::glPushAttrib(_a); }
void YAC_CALL _glPopClientAttrib(void)              { ::glPopClientAttrib(); }
void YAC_CALL _glPushClientAttrib(sSI _a)           { ::glPushClientAttrib(_a); }
void YAC_CALL _glPopMatrix(void)                    { ::glPopMatrix(); }
void YAC_CALL _glPushMatrix(void)                   { ::glPushMatrix(); }
void YAC_CALL _glRasterPos2i(sSI _a, sSI _b)        { ::glRasterPos2i(_a, _b); }
void YAC_CALL _glRasterPos3f(sF32 _a, sF32 _b, 
					sF32 _c)               { ::glRasterPos3f(_a, _b, _c); }
void YAC_CALL _glReadBuffer(sSI _a)                 { ::glReadBuffer(_a); }
void YAC_CALL _glRectf(sF32 _a, sF32 _b, sF32 _c, 
				  sF32 _d)                 { ::glRectf(_a, _b, _c, _d); }
void YAC_CALL _glRotatef(sF32 _a, sF32 _b, 
				sF32 _c, sF32 _d)          { ::glRotatef(_a, _b, _c, _d); }
void YAC_CALL _glScalef(sF32 _a, sF32 _b, sF32 _c)  { ::glScalef(_a, _b, _c); }
void YAC_CALL _glScissor(sSI _a, sSI _b, 
				sSI _c, sSI _d)            { ::glScissor(_a, _b, _c, _d); }
void YAC_CALL _glShadeModel(sSI _a)                 { ::glShadeModel(_a); }
void YAC_CALL _glStencilFunc(sSI _a, sSI _b, 
						sSI _c)            { ::glStencilFunc(_a, _b, _c); }
void YAC_CALL _glStencilOp(sSI _a, sSI _b, 
					  sSI _c)              { ::glStencilOp(_a, _b, _c); }
void YAC_CALL _glStencilMask(sSI _a)                { ::glStencilMask(_a); }
void YAC_CALL _glTexCoord1f(sF32 _a)                { ::glTexCoord1f(_a); }
void YAC_CALL _glTexCoord2f(sF32 _a, sF32 _b)       { ::glTexCoord2f(_a, _b); }
void YAC_CALL _glTexCoord1i(sSI _a)                 { ::glTexCoord1i(_a); }
void YAC_CALL _glTexCoord2i(sSI _a, sSI _b)         { ::glTexCoord2i(_a, _b); }
void YAC_CALL _glTexGeni(sSI _a, sSI _b, sSI _c)    { ::glTexGeni(_a, _b, _c); }
void YAC_CALL _glTranslatef(sF32 _a, sF32 _b, 
				   sF32 _c)                { ::glTranslatef(_a, _b, _c); }
void YAC_CALL _glVertex2i(sSI _a, sSI _b)           { ::glVertex2i(_a, _b); }
void YAC_CALL _glVertex2f(sF32 _a, sF32 _b)         { ::glVertex2f(_a, _b); }
void YAC_CALL _glVertex3f(sF32 _a, sF32 _b, sF32 _c) { ::glVertex3f(_a, _b, _c); }
void YAC_CALL _glViewport(sSI _a, sSI _b, 
				 sSI _c, sSI _d)           { ::glViewport(_a, _b, _c, _d); }


void YAC_CALL _zglInitPerspective(sF32 _aspect, sF32 _fov, sF32 _znear, sF32 _zfar) {
	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	double top=::tan(_fov*sM_PI*2.0*(1.0/360.0)*0.5)*_znear;
	::glFrustum(_aspect*-top, _aspect*top, -top, top, _znear, _zfar);
	::glMatrixMode(GL_MODELVIEW);
}

void YAC_CALL _zglInitOrtho(sF32 _sx, sF32 _sy) {
	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	::glOrtho(-_sx, _sx, _sy, -_sy, -1.0f, 1.0f);
	::glMatrixMode(GL_MODELVIEW);
}

void YAC_CALL _zglInit2D(sF32 _sx, sF32 _sy) {
	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	::glOrtho(0.0f, _sx, _sy, 0.0f, -1.0f, 1.0f);
	::glMatrixMode(GL_MODELVIEW);
}


void YAC_CALL _zgluLookAt(YAC_Object *_eye, YAC_Object *_center, YAC_Object *_up) {
	if(YAC_CHK(_eye, clid_Vector))
	if(YAC_CHK(_center, clid_Vector))
	if(YAC_CHK(_up, clid_Vector))
	{
		_Vector *eye=(_Vector*)_eye;
		_Vector *center=(_Vector*)_center;
		_Vector *up=(_Vector*)_up;
		::gluLookAt(eye->x, eye->y, eye->z,
			  center->x, center->y, center->z,
			  up->x, up->y, up->z
		);
	}
}

void YAC_CALL _zglScalev(YAC_Object *_v) {
	if(YAC_CHK(_v, clid_Vector))
	{
		_Vector *v=(_Vector*)_v;
		::glScalef(v->x, v->y, v->z);
	}
}

void YAC_CALL _zglTranslatev(YAC_Object *_v) {
    if(YAC_CHK(_v, clid_Vector))
    {
		_Vector *v=(_Vector*)_v;
		::glTranslatef(v->x, v->y, v->z);
    }
}

void YAC_CALL _zglRotatev(YAC_Object *_v) {
	if(YAC_CHK(_v, clid_Matrix))
	{
		_Matrix *m=(_Matrix *)_v;
		GLfloat tm[16];
		
		tm[0]=m->i.x;
		tm[4]=m->i.y;
		tm[8]=m->i.z;
		tm[12]=0;
		
		tm[1]=m->j.x;
		tm[5]=m->j.y;
		tm[9]=m->j.z;
		tm[13]=0;
		
		tm[2]=m->k.x;
		tm[6]=m->k.y;
		tm[10]=m->k.z;
		tm[14]=tm[3]=tm[7]=tm[11]=0;
		tm[15]=1.0f;
		
		::glMultMatrixf(tm);
	}
	else
	{
		if(YAC_CHK(_v, clid_Vector))
		{
			_Vector *v=(_Vector*)_v;
			_Matrix m;
			m.class_ID=clid_Matrix;
			sF32 sc=(sF32)(2.0f*sM_PI/360.0f);
			m.init((sF32)(v->x*sc), (sF32)(v->y*sc), (sF32)(v->z*sc));
			_zglRotatev(&m);
		}
	}
}

void YAC_CALL _zglNormalv(YAC_Object *_v) {
	if(YAC_CHK(_v, clid_Vector))
	{
		_Vector *v=(_Vector*)_v;
		::glNormal3f(v->x, v->y, v->z);
	}
}

void YAC_CALL _zglVertexv(YAC_Object *_v) {
	if(YAC_CHK(_v, clid_Vector))
	{
		_Vector *v=(_Vector*)_v;
		::glVertex3f(v->x, v->y, v->z);
	}
}

void YAC_CALL _zglRotate3f(sF32 _a, sF32 _b, sF32 _c) {
	_Matrix m;
	m.class_ID=clid_Matrix;
	double sc=2.0*sM_PI/360.0;
	m.init((sF32)(_a*sc), (sF32)(_b*sc), (sF32)(_c*sc));
	_zglRotatev(&m);
}


void YAC_CALL _zglLoadMatrix(YAC_Object *_m, YAC_Object *_v) {
    if(YAC_CHK(_m, clid_Matrix))
	if(YAC_CHK(_v, clid_Vector))
        {
            _Matrix *m=(_Matrix*)_m;
			_Vector *v=(_Vector*)_v;
			GLfloat ma[16];

			ma[0] =m->i.x;
			ma[4] =m->i.y;
			ma[8] =m->i.z;

			ma[1] =m->j.x;
			ma[5] =m->j.y;
			ma[9] =m->j.z;

			ma[2] =m->k.x;
			ma[6] =m->k.y;
			ma[10]=m->k.z; 

			ma[3] =0.0f;
			ma[7] =0.0f;
			ma[11] =0.0f;

			ma[12]=v->x;
			ma[13]=v->y;
			ma[14]=v->z;
			ma[15]=1.0f;

			::glLoadMatrixf((const GLfloat*)ma);
        }
}	

void YAC_CALL _zglStoreMatrix(YAC_Object *_m, YAC_Object *_v) {
    if(YAC_CHK(_m, clid_Matrix))
	if(YAC_CHK(_v, clid_Vector))
        {
            _Matrix *m=(_Matrix*)_m;
			_Vector *v=(_Vector*)_v;
			GLfloat ma[16];
			GLint mm;
			::glGetIntegerv(GL_MATRIX_MODE, &mm);
			switch(mm)
			{
			default: case GL_MODELVIEW: ::glGetFloatv(GL_MODELVIEW_MATRIX, ma); break;
			case GL_PROJECTION: ::glGetFloatv(GL_PROJECTION_MATRIX, ma); break;
			case GL_TEXTURE: ::glGetFloatv(GL_TEXTURE_MATRIX, ma); break;
			}
			
			m->i.x=ma[0];
			m->i.y=ma[4];
			m->i.z=ma[8];

			m->j.x=ma[1];
			m->j.y=ma[5];
			m->j.z=ma[9];

			m->k.x=ma[2];
			m->k.y=ma[6];
			m->k.z=ma[10]; 

			v->x=ma[12];
			v->y=ma[13];
			v->z=ma[14];
		}
}

void YAC_CALL _zglFrustum(sF32 _aspect, sF32 _fov, sF32 _znear, sF32 _zfar) {
	double top=tan(_fov*sM_PI*2.0*(1.0/360.0)*0.5)*_znear;
	::glFrustum(_aspect*-top, _aspect*top, -top, top, _znear, _zfar);
}

void YAC_CALL _zglLightAmbient4f(sSI _lightnr, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glLightfv(_lightnr, GL_AMBIENT, rgba);
}

void YAC_CALL _zglLightDiffuse4f(sSI _lightnr, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glLightfv(_lightnr, GL_DIFFUSE, rgba);
}

void YAC_CALL _zglLightSpecular4f(sSI _lightnr, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glLightfv(_lightnr, GL_SPECULAR, rgba);
}

void YAC_CALL _zglLightPositionf(sSI _lightnr, sF32 _x, sF32 _y, sF32 _z) {
    GLfloat xyz[4]={_x, _y, _z, 1.0f};
	::glLightfv(_lightnr, GL_POSITION, xyz);
}

void YAC_CALL _zglLightPositionv(sSI _lightnr, YAC_Object *_v, sF32 _w) {
    if(YAC_CHK(_v, clid_Vector))
    {
        _Vector *v=(_Vector*)_v;
        GLfloat xyz[4];
        xyz[0]=v->x;
        xyz[1]=v->y;
        xyz[2]=v->z;
        xyz[3]=_w;
		::glLightfv(_lightnr, GL_POSITION, xyz);
    }
}

void YAC_CALL _zglLightSpotDirectionf(sSI _lightnr, sF32 _x, sF32 _y, sF32 _z) {
    sF32 xyz[3]={_x, _y, _z};
	::glLightfv(_lightnr, GL_SPOT_DIRECTION, xyz);
}

void YAC_CALL _zglLightSpotDirectionv(sSI _lightnr, YAC_Object *_v) {
    if(YAC_CHK(_v, clid_Vector))
    {
        _Vector *v=(_Vector*)_v;
        sF32 xyz[3]={v->x, v->y, v->z};
		::glLightfv(_lightnr, GL_SPOT_DIRECTION, xyz);
    }
}

void YAC_CALL _zglLightSpotExponent(sSI _lightnr, sSI _exponent) {
	::glLighti(_lightnr, GL_SPOT_EXPONENT, _exponent);
}

void YAC_CALL _zglLightSpotCutOff(sSI _lightnr, sSI _deg) {
	::glLighti(_lightnr, GL_SPOT_CUTOFF, _deg);
}

void YAC_CALL _zglLightConstantAttenuation(sSI _lightnr, sF32 _v) {
	::glLightf(_lightnr, GL_CONSTANT_ATTENUATION, _v);
}

void YAC_CALL _zglLightLinearAttenuation(sSI _lightnr, sF32 _v) {
	::glLightf(_lightnr, GL_LINEAR_ATTENUATION, _v);
}

void YAC_CALL _zglLightQuadraticAttenuation(sSI _lightnr, sF32 _v) {
    ::glLightf(_lightnr, GL_QUADRATIC_ATTENUATION, _v);
}

void YAC_CALL _zglLightModelAmbient4f(sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
    ::glLightModelfv(GL_LIGHT_MODEL_AMBIENT,  rgba);
}

void YAC_CALL _zglLightModelLocalViewer(sSI _eyeorigin) {
    ::glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,  _eyeorigin);
}

void YAC_CALL _zglLightModelTwoSide(sSI _enabled) {
    ::glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,  _enabled);
}

void YAC_CALL _zglLightMaterialAmbient4f(sSI _face, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glMaterialfv(_face, GL_AMBIENT, rgba);
}

void YAC_CALL _zglLightMaterialDiffuse4f(sSI _face, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glMaterialfv(_face,GL_DIFFUSE, rgba);
}

void YAC_CALL _zglLightMaterialSpecular4f(sSI _face, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glMaterialfv(_face, GL_SPECULAR, rgba);
}

void YAC_CALL _zglLightMaterialEmission4f(sSI _face, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glMaterialfv(_face, GL_EMISSION, rgba);
}

void YAC_CALL _zglLightMaterialShininess(sSI _face, sSI _exp) {
	::glMateriali(_face, GL_SHININESS, _exp);
}

void YAC_CALL _zglLightMaterialAmbientAndDiffuse4f(sSI _face, sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
	::glMaterialfv(_face, GL_AMBIENT_AND_DIFFUSE, rgba);
}

void YAC_CALL _zglFogMode(sSI _equation) {
    ::glFogi(GL_FOG_MODE, _equation);
}

void YAC_CALL _zglFogDensity(sF32 _d) {
    ::glFogf(GL_FOG_DENSITY, _d);
}

void YAC_CALL _zglFogStart(sF32 _znear) {
    ::glFogf(GL_FOG_START, _znear);
}

void YAC_CALL _zglFogEnd(sF32 _zfar) {
    ::glFogf(GL_FOG_END, _zfar);
}

void YAC_CALL _zglFogColor4f(sF32 _r, sF32 _g, sF32 _b, sF32 _a) {
    GLfloat rgba[4];
    rgba[0]=_r;
    rgba[1]=_g;
    rgba[2]=_b;
    rgba[3]=_a;
    ::glFogfv(GL_FOG_COLOR, rgba);
}

void YAC_CALL _zglColorARGB(sSI _argb) {
	sU8 rgba[4];
	rgba[0]=(sU8) (((sU32)_argb)>>16);
	rgba[1]=(sU8) (((sU32)_argb)>>8 );
	rgba[2]=(sU8) (((sU32)_argb)    );
	rgba[3]=(sU8) (((sU32)_argb)>>24);
	::glColor4ubv(rgba);
}


void YAC_CALL _zglVertexPointer(YAC_Object *_fa) {
	if(_fa)
		if(_fa->yacArrayGetElementType()==2)
		{
			void *e=_fa->yacArrayGetPointer();
			if(e) ::glVertexPointer(3, GL_FLOAT, 0, e);
		}
}

void YAC_CALL _zglNormalPointer(YAC_Object *_fa) {
	if(_fa)
		if(_fa->yacArrayGetElementType()==2)
		{
			void *e=_fa->yacArrayGetPointer();
			if(e) ::glNormalPointer(GL_FLOAT, 0, e);
		}
}

void YAC_CALL _zglColorPointer3f(YAC_Object *_fa) {
	if(_fa)
		if(_fa->yacArrayGetElementType()==2)
		{
			void *e=_fa->yacArrayGetPointer();
			if(e) ::glColorPointer(3, GL_FLOAT, 0, e);
		}
}

void YAC_CALL _zglColorPointer4f(YAC_Object *_fa) {
	if(_fa)
		if(_fa->yacArrayGetElementType()==2)
		{
			void *e=_fa->yacArrayGetPointer();
			if(e) ::glColorPointer(4, GL_FLOAT, 0, e);
		}
}

void YAC_CALL _zglColorPointer4b(YAC_Object *_fa) {
	if(_fa)
		if(_fa->yacArrayGetElementType()==1)
		{
			void *e=_fa->yacArrayGetPointer();
			if(e) ::glColorPointer(4, GL_BYTE, 0, e);
		}
}

void YAC_CALL _zglTexCoordPointer2f(YAC_Object *_fa) {
	if(_fa)
		if(_fa->yacArrayGetElementType()==2)
		{
			void *e=_fa->yacArrayGetPointer();
			if(e) ::glTexCoordPointer(2, GL_FLOAT, 0, e);
		}
}




