/// tksopengl.h
///
/// (c) 2001-2006 Bastian Spiegel <bs@tkscript.de>
///     - distributed under the terms of the GNU general public license (GPL)
///
///

#ifndef __TKSOPENGL_H__
#define __TKSOPENGL_H__


YG("OpenGL");


// ---- tkscript / YAC uses the cdecl calling convention while the GL may use stdcall ----
YF YAC_Object *YAC_CALL _ivector                (sSI, sSI);
YF YAC_Object *YAC_CALL _vector                 (sF32, sF32, sF32);
YF YAC_Object *YAC_CALL _vector4                (sF32, sF32, sF32, sF32);
YF sUI         YAC_CALL _mathC32Multiply        (sUI, sUI, sF32 _bscale);
YF sUI         YAC_CALL _mathC32Blend           (sUI, sUI, sF32 _bscale);
YF void        YAC_CALL _mathNormal             (YAC_Object *, YAC_Object *, YAC_Object *, YAC_Object *);
YF void        YAC_CALL _mathUnproject          (YAC_Object *, YAC_Object *, YAC_Object *);
YF void        YAC_CALL _mathProject            (YAC_Object *, YAC_Object *);
YF void        YAC_CALL _mathReflect            (YAC_Object *, YAC_Object *, YAC_Object *);
YF sF32        YAC_CALL _mathDistancePointPlane (YAC_Object *, YAC_Object *, YAC_Object *);
YF void        YAC_CALL _mathVectorMin          (YAC_Object *, YAC_Object *, YAC_Object *);
YF void        YAC_CALL _mathVectorMax          (YAC_Object *, YAC_Object *, YAC_Object *);
YF sUI         YAC_CALL _mathC32ToC8            (sUI);

YF void        YAC_CALL _glAlphaFunc            (sSI, sF32);
YF void        YAC_CALL _glArrayElement         (sSI);
YF void        YAC_CALL _glBegin                (sSI);
YF void        YAC_CALL _glBindTexture          (sSI, sSI);
YF void        YAC_CALL _glBlendFunc            (sSI, sSI);
YF void        YAC_CALL _glCallList             (sSI);
YF void        YAC_CALL _glCullFace             (sSI);
YF void        YAC_CALL _glClearColor           (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _glClear                (sSI);
YF void        YAC_CALL _glClearDepth           (sF32);
YF void        YAC_CALL _glClearStencil         (sSI);
YF void        YAC_CALL _glColor3f              (sF32, sF32, sF32);
YF void        YAC_CALL _glColor3ub             (sSI _a, sSI _b, sSI _c);
YF void        YAC_CALL _glColor4f              (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _glColor4ub             (sSI, sSI, sSI, sSI);
YF void        YAC_CALL _glColorMask            (sSI, sSI, sSI, sSI);
YF void        YAC_CALL _glCopyPixels           (sSI, sSI, sSI, sSI, sSI);
YF void        YAC_CALL _glCopyTexSubImage2D    (sSI, sSI, sSI, sSI, sSI, sSI, sSI, sSI);
YF void        YAC_CALL _glCopyTexImage2D       (sSI, sSI, sSI, sSI, sSI, sSI, sSI, sSI);
YF void        YAC_CALL _glDepthFunc            (sSI);
YF void        YAC_CALL _glDepthMask            (sSI);
YF void        YAC_CALL _glDisable              (sSI);
YF void        YAC_CALL _glDisableClientState   (sSI);
YF void        YAC_CALL _glDrawArrays           (sSI, sSI, sSI);
YF void        YAC_CALL _glDrawElements         (sSI, YAC_Object *_indices); /** NEW **/
YF void        YAC_CALL _glDrawBuffer           (sSI);
YF void        YAC_CALL _glEdgeFlag             (sSI);
YF void        YAC_CALL _glEnable               (sSI);
YF void        YAC_CALL _glEnableClientState    (sSI);
YF void        YAC_CALL _glEnd                  (void);
YF void        YAC_CALL _glFinish               (void);
YF void        YAC_CALL _glFlush                (void);
YF void        YAC_CALL _glFrontFace            (sSI);
YF void        YAC_CALL _glFrustum              (sF32, sF32, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _glHint                 (sSI, sSI);
YF void        YAC_CALL _glLoadIdentity         (void);
YF void        YAC_CALL _glLineWidth            (sF32);
YF void        YAC_CALL _glLineStipple          (sSI, sSI);
YF void        YAC_CALL _glLogicOp              (sSI);
YF void        YAC_CALL _glMatrixMode           (sSI);
YF void        YAC_CALL _glNormal3f             (sF32, sF32, sF32);
YF void        YAC_CALL _glOrtho                (sF32, sF32, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _glPointSize            (sF32);
YF void        YAC_CALL _glPixelZoom            (sF32, sF32);
YF void        YAC_CALL _glPolygonMode          (sSI, sSI);
YF void        YAC_CALL _glPopAttrib            (void);
YF void        YAC_CALL _glPushAttrib           (sSI);
YF void        YAC_CALL _glPopClientAttrib      (void);
YF void        YAC_CALL _glPushClientAttrib     (sSI);
YF void        YAC_CALL _glPopMatrix            (void);
YF void        YAC_CALL _glPushMatrix           (void);
YF void        YAC_CALL _glRasterPos2i          (sSI, sSI);
YF void        YAC_CALL _glRasterPos3f          (sF32, sF32, sF32);
YF void        YAC_CALL _glReadBuffer           (sSI);
YF void        YAC_CALL _glRectf                (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _glRotatef              (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _glScalef               (sF32, sF32, sF32);
YF void        YAC_CALL _glScissor              (sSI, sSI, sSI, sSI);
YF void        YAC_CALL _glShadeModel           (sSI);
YF void        YAC_CALL _glStencilFunc          (sSI, sSI, sSI);
YF void        YAC_CALL _glStencilOp            (sSI, sSI, sSI);
YF void        YAC_CALL _glStencilMask          (sSI);
YF void        YAC_CALL _glTexCoord1f           (sF32);
YF void        YAC_CALL _glTexCoord2f           (sF32, sF32);
YF void        YAC_CALL _glTexCoord1i           (sSI); // xxx
YF void        YAC_CALL _glTexCoord2i           (sSI, sSI); // XXX
YF void        YAC_CALL _glTexGeni              (sSI, sSI, sSI);
YF void        YAC_CALL _glTranslatef           (sF32, sF32, sF32);
YF void        YAC_CALL _glVertex2i             (sSI, sSI);
YF void        YAC_CALL _glVertex2f             (sF32, sF32);
YF void        YAC_CALL _glVertex3f             (sF32, sF32, sF32);
YF void        YAC_CALL _glViewport             (sSI, sSI, sSI, sSI);
YF void        YAC_CALL _zglColor1f             (sF32);
YF void        YAC_CALL _zglInitPerspective     (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglInitOrtho           (sF32, sF32);
YF void        YAC_CALL _zglInit2D              (sF32, sF32);
YF void        YAC_CALL _zgluLookAt             (YAC_Object *, YAC_Object *, YAC_Object *);
YF void        YAC_CALL _zglScalev              (YAC_Object *);
YF void        YAC_CALL _zglTranslatev          (YAC_Object *);
YF void        YAC_CALL _zglRotatev             (YAC_Object *);
YF void        YAC_CALL _zglNormalv             (YAC_Object *);
YF void        YAC_CALL _zglVertexv             (YAC_Object *);
YF void        YAC_CALL _zglRotate3f            (sF32, sF32, sF32);
YF void        YAC_CALL _zglLoadMatrix          (YAC_Object *, YAC_Object *);
YF void        YAC_CALL _zglStoreMatrix         (YAC_Object *, YAC_Object *);
YF void        YAC_CALL _zglFrustum             (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightAmbient4f      (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightDiffuse4f      (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightSpecular4f     (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightPositionf      (sSI, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightPositionv      (sSI, YAC_Object *, sF32);
YF void        YAC_CALL _zglLightSpotDirectionf (sSI, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightSpotDirectionv (sSI, YAC_Object *);
YF void        YAC_CALL _zglLightSpotExponent   (sSI, sSI);
YF void        YAC_CALL _zglLightSpotCutOff     (sSI, sSI);
YF void        YAC_CALL _zglLightConstantAttenuation (sSI, sF32);
YF void        YAC_CALL _zglLightLinearAttenuation   (sSI, sF32);
YF void        YAC_CALL _zglLightQuadraticAttenuation(sSI, sF32);
YF void        YAC_CALL _zglLightModelAmbient4f      (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightModelLocalViewer    (sSI);
YF void        YAC_CALL _zglLightModelTwoSide        (sSI);
YF void        YAC_CALL _zglLightMaterialAmbient4f   (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightMaterialDiffuse4f   (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightMaterialSpecular4f  (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightMaterialEmission4f  (sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglLightMaterialShininess   (sSI, sSI);
YF void        YAC_CALL _zglLightMaterialAmbientAndDiffuse4f(sSI, sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglFogMode             (sSI);
YF void        YAC_CALL _zglFogDensity          (sF32);
YF void        YAC_CALL _zglFogStart            (sF32);
YF void        YAC_CALL _zglFogEnd              (sF32);
YF void        YAC_CALL _zglFogColor4f          (sF32, sF32, sF32, sF32);
YF void        YAC_CALL _zglColorARGB           (sSI);
YF void        YAC_CALL _zglVertexPointer       (YAC_Object *);
YF void        YAC_CALL _zglNormalPointer       (YAC_Object *);
YF void        YAC_CALL _zglColorPointer3f      (YAC_Object *);
YF void        YAC_CALL _zglColorPointer4f      (YAC_Object *);
YF void        YAC_CALL _zglColorPointer4b      (YAC_Object *);
YF void        YAC_CALL _zglTexCoordPointer2f   (YAC_Object *);
YF sUI         YAC_CALL _zglReadColorPixel      (sSI, sSI);
YF sF32        YAC_CALL _zglReadDepthPixel      (sSI, sSI);
YF void        YAC_CALL _zglClipPlane           (sSI _i, sF32 _eq0, sF32 _eq1, sF32 _eq2, sF32 _eq3);




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~                                                                ~
//~ DisplayList                                                    ~
//~                                                                ~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
YC class _DisplayList : public YAC_Object {
public:
	sSI        gl_dlist;
    YAC_String name;

public:
	_DisplayList(void);
	~_DisplayList();

	YAC(_DisplayList);

	// the following lines are not comments but they rather represent a constant export table

//#define GL_MODELVIEW                   YCI 0x1700
//#define GL_PROJECTION                  YCI 0x1701
//#define GL_TEXTURE                     YCI 0x1702
//#define GL_FOG_HINT                    YCI 0x0C54
//#define GL_LINE_SMOOTH_HINT            YCI 0x0C52
//#define GL_PERSPECTIVE_CORRECTION_HINT YCI 0x0C50
//#define GL_POINT_SMOOTH_HINT           YCI 0x0C51
//#define GL_POLYGON_SMOOTH_HINT         YCI 0x0C53
//#define GL_FASTEST                     YCI 0x1101
//#define GL_NICEST                      YCI 0x1102
//#define GL_DONT_CARE                   YCI 0x1100
//#define GL_ALPHA_TEST                  YCI 0x0BC0
//#define GL_AUTO_NORMAL                 YCI 0x0D80
//#define GL_BLEND                       YCI 0x0BE2
//#define GL_CULL_FACE                   YCI 0x0B44
//#define GL_DEPTH_TEST                  YCI 0x0B71
//#define GL_DITHER                      YCI 0x0BD0
//#define GL_FOG                         YCI 0x0B60
//#define GL_LIGHT0                      YCI 0x4000
//#define GL_LIGHT1                      YCI 0x4001
//#define GL_LIGHT2                      YCI 0x4002
//#define GL_LIGHT3                      YCI 0x4003
//#define GL_LIGHT4                      YCI 0x4004
//#define GL_LIGHT5                      YCI 0x4005
//#define GL_LIGHT6                      YCI 0x4006
//#define GL_LIGHT7                      YCI 0x4007
//#define GL_LIGHTING                    YCI 0x0B50
//#define GL_LINE_SMOOTH                 YCI 0x0B20
//#define GL_LINE_STIPPLE                YCI 0x0B24
//#define GL_NORMALIZE                   YCI 0x0BA1
//#define GL_POINT_SMOOTH                YCI 0x0B10
//#define GL_POLYGON_OFFSET_FILL         YCI 0x8037
//#define GL_POLYGON_OFFSET_POINT        YCI 0x2A01
//#define GL_POLYGON_SMOOTH              YCI 0x0B41
//#define GL_POLYGON_STIPPLE             YCI 0x0B42
//#define GL_SCISSOR_TEST                YCI 0x0C11
//#define GL_STENCIL_TEST                YCI 0x0B90
//#define GL_TEXTURE_1D                  YCI 0x0DE0
//#define GL_TEXTURE_2D                  YCI 0x0DE1
//#define GL_TEXTURE_3D                  YCI 0x806F
//#define GL_CLEAR                       YCI 0x1500
//#define GL_SET                         YCI 0x150F
//#define GL_COPY                        YCI 0x1503
//#define GL_COPY_INVERTED               YCI 0x150c
//#define GL_NOOP                        YCI 0x1505
//#define GL_INVERT                      YCI 0x150a
//#define GL_AND                         YCI 0x1501
//#define GL_NAND                        YCI 0x150e
//#define GL_OR                          YCI 0x1507
//#define GL_NOR                         YCI 0x1508
//#define GL_XOR                         YCI 0x1506
//#define GL_EQUIV                       YCI 0x1509
//#define GL_AND_REVERSE                 YCI 0x1502
//#define GL_AND_INVERTED                YCI 0x1504
//#define GL_OR_REVERSE                  YCI 0x150b
//#define GL_OR_INVERTED                 YCI 0x150d
//#define GL_RENDER                      YCI 0x1C00
//#define GL_FEEDBACK                    YCI 0x1C01
//#define GL_SELECT                      YCI 0x1C02
//#define GL_FLAT                        YCI 0x1D00
//#define GL_SMOOTH                      YCI 0x1D01
//#define GL_FRONT                       YCI 0x0404
//#define GL_BACK                        YCI 0x0405
//#define GL_FRONT_AND_BACK              YCI 0x0408
//#define GL_POINT                       YCI 0x1b00
//#define GL_LINE                        YCI 0x1b01
//#define GL_FILL                        YCI 0x1b02
//#define GL_ZERO                        YCI 0x0
//#define GL_ONE                         YCI 0x1
//#define GL_SRC_COLOR                   YCI 0x0300
//#define GL_ONE_MINUS_SRC_COLOR         YCI 0x0301
//#define GL_SRC_ALPHA                   YCI 0x0302
//#define GL_ONE_MINUS_SRC_ALPHA         YCI 0x0303
//#define GL_DST_ALPHA                   YCI 0x0304
//#define GL_ONE_MINUS_DST_ALPHA         YCI 0x0305
//#define GL_DST_COLOR                   YCI 0x0306
//#define GL_ONE_MINUS_DST_COLOR         YCI 0x0307
//#define GL_SRC_ALPHA_SATURATE          YCI 0x0308
//#define GL_CW                          YCI 0x0900
//#define GL_CCW                         YCI 0x0901
//#define GL_KEEP                        YCI 0x1E00
//#define GL_REPLACE                     YCI 0x1E01
//#define GL_INCR                        YCI 0x1E02
//#define GL_DECR                        YCI 0x1E03
//#define GL_NEVER                       YCI 0x0200
//#define GL_LESS                        YCI 0x0201
//#define GL_EQUAL                       YCI 0x0202
//#define GL_LEQUAL                      YCI 0x0203
//#define GL_GREATER                     YCI 0x0204
//#define GL_NOTEQUAL                    YCI 0x0205
//#define GL_GEQUAL                      YCI 0x0206
//#define GL_ALWAYS                      YCI 0x0207
//#define GL_POLYGON_OFFSET_LINE         YCI 0x2a02
//#define GL_VERTEX_ARRAY                YCI 0x8074
//#define GL_NORMAL_ARRAY                YCI 0x8075
//#define GL_COLOR_ARRAY                 YCI 0x8076
//#define GL_TEXTURE_COORD_ARRAY         YCI 0x8078
//#define GL_COLOR_LOGIC_OP              YCI 0x0bf2
//#define GL_S                           YCI 0x2000
//#define GL_T                           YCI 0x2001
//#define GL_R                           YCI 0x2002
//#define GL_Q                           YCI 0x2003
//#define GL_TEXTURE_GEN_S               YCI 0x0c60
//#define GL_TEXTURE_GEN_T               YCI 0x0c61
//#define GL_TEXTURE_GEN_R               YCI 0x0c62
//#define GL_TEXTURE_GEN_Q               YCI 0x0c63
//#define GL_EYE_LINEAR                  YCI 0x2400
//#define GL_OBJECT_LINEAR               YCI 0x2401
//#define GL_SPHERE_MAP                  YCI 0x2402
//#define GL_TEXTURE_GEN_MODE            YCI 0x2500
//#define GL_OBJECT_PLANE                YCI 0x2501
//#define GL_EYE_PLANE                   YCI 0x2502
//#define GL_COLOR                       YCI 0x1800
//#define GL_DEPTH                       YCI 0x1801
//#define GL_STENCIL                     YCI 0x1802
//#define GL_COLOR_INDEX                 YCI 0x1900
//#define GL_STENCIL_INDEX               YCI 0x1901
//#define GL_DEPTH_COMPONENT             YCI 0x1902
//#define GL_RED                         YCI 0x1903
//#define GL_GREEN                       YCI 0x1904
//#define GL_BLUE                        YCI 0x1905
//#define GL_ALPHA                       YCI 0x1906
//#define GL_RGB                         YCI 0x1907
//#define GL_RGBA                        YCI 0x1908
//#define GL_LUMINANCE                   YCI 0x1909
//#define GL_LUMINANCE8                  YCI 0x8040
//#define GL_LUMINANCE_ALPHA             YCI 0x190a
//#define GL_LUMINANCE8_ALPHA8           YCI 0x8045
//#define GL_INTENSITY                   YCI 0x8049
//#define GL_INTENSITY8                  YCI 0x804b
//#define GL_RGB5                        YCI 0x8050
//#define GL_RGB8                        YCI 0x8051
//#define GL_RGB5_A1                     YCI 0x8057
//#define GL_RGBA8                       YCI 0x8058
//#define GL_RGB10_A2                    YCI 0x8059
//#define GL_R3_G3_B2                    YCI 0x2a10
//#define GL_CURRENT_BIT                 YCI 0x1
//#define GL_ENABLE_BIT                  YCI 0x2000
//#define GL_EVAL_BIT                    YCI 0x10000
//#define GL_FOG_BIT                     YCI 0x80
//#define GL_HINT_BIT                    YCI 0x8000
//#define GL_LIGHTING_BIT                YCI 0x40
//#define GL_LINE_BIT                    YCI 0x4
//#define GL_LIST_BIT                    YCI 0x20000
//#define GL_PIXEL_MODE_BIT              YCI 0x20
//#define GL_POINT_BIT                   YCI 0x2
//#define GL_POLYGON_BIT                 YCI 0x8
//#define GL_POLYGON_STIPPLE_BIT         YCI 0x10
//#define GL_SCISSOR_BIT                 YCI 0x80000
//#define GL_TEXTURE_BIT                 YCI 0x40000
//#define GL_TRANSFORM_BIT               YCI 0x1000
//#define GL_VIEWPORT_BIT                YCI 0x800
//#define GL_ALL_ATTRIBS_BITS            YCI 0xFFFFF
//#define GL_CLIENT_PIXEL_STORE_BIT      YCI 0x1
//#define GL_CLIENT_VERTEX_ARRAY_BIT     YCI 0x2
//#define GL_CLIENT_ALL_ATTRIB_BITS      YCI 0xFFFFFFFF
//#define GL_BGRA_EXT                    YCI 0x80E1
//#define GL_BGR_EXT                     YCI 0x80E0
//#define GL_SPOT_EXPONENT               YCI 0x1205
//#define GL_SPOT_CUTOFF                 YCI 0x1206
//#define GL_CONSTANT_ATTENUATION        YCI 0x1207
//#define GL_LINEAR_ATTENUATION          YCI 0x1208
//#define GL_QUADRATIC_ATTENUATION       YCI 0x1209
//#define GL_POINTS                      YCI 0x0
//#define GL_LINES                       YCI 0x1
//#define GL_LINE_STRIP                  YCI 0x3
//#define GL_LINE_LOOP                   YCI 0x2
//#define GL_TRIANGLES                   YCI 0x4
//#define GL_TRIANGLE_STRIP              YCI 0x5
//#define GL_TRIANGLE_FAN                YCI 0x6
//#define GL_QUADS                       YCI 0x7
//#define GL_QUAD_STRIP                  YCI 0x8
//#define GL_POLYGON                     YCI 0x9
//#define GL_LINEAR                      YCI 0x2601
//#define GL_EXP                         YCI 0x0800
//#define GL_EXP2                        YCI 0x0801
//#define GL_COLOR_BUFFER_BIT            YCI 0x4000
//#define GL_DEPTH_BUFFER_BIT            YCI 0x100
//#define GL_ACCUM_BUFFER_BIT            YCI 0x200
//#define GL_STENCIL_BUFFER_BIT          YCI 0x400
//#define GL_CLIP_PLANE0                 YCI 0x3000
//#define GL_CLIP_PLANE1                 YCI 0x3001
//#define GL_CLIP_PLANE2                 YCI 0x3002
//#define GL_CLIP_PLANE3                 YCI 0x3003
//#define GL_CLIP_PLANE4                 YCI 0x3004
//#define GL_CLIP_PLANE5                 YCI 0x3005
	void YAC_CALL yacOperator(sSI _op, YAC_Object *_o, YAC_Value *);

	YM void        _alloc   (void);
	YM void        _free    (void);
	YM void        _begin   (void);
	YM void        _end     (void);
	YM void        _draw    (void);
	YM void        _setName (YAC_String *);
	YM YAC_String *_getName (void);
	YM sSI         _getId   (void);
};


#endif

